from datetime import *

class Event():
    def __init__(self, desc, dd, t, dur=60):
        '''Initialize an Event given:
        - str desc that denotes its description
        - date object dd containing the year, month and day of the event
        - a tuple t in the form (hour,minute). hour 0-23, minute is 0-59
                If t is None, the event is an all-day event.
        - int dur which denotes the duration of the event
        '''
        pass
        
    def timerep(self):
        '''Return a string representation of the Event in the following form:
        All day events: "ALL DAY - Event description"
        Timed events:   "  HH:MM - Event description (xx minutes)"
        hh is 00-23, mm is 00-59, xx is 0-999
        '''

        pass
        
    def __str__(self):
        '''Return a string representation of the Event in the following form:
        All day events: "YYYY-MM-DD ALL DAY - Event description"
        Timed events:   "YYYY-MM-DD   hh:mm - Event description (xx minutes)"
        YYYY is 1000-9999, MM is 01-12, DD is 01-31, hh is 00-23, mm is 00-59, xx is 0-999
        '''

        pass
        
        
    def __cmp__(self, other):
        ''' If self is 'greater' than other, return 1.
        If other is 'greater' than self, return -1.
        All-day events are 'greater' than any timed events on the same day
        'Greater' events occur earlier than 'lesser' events.
        Two events that start at the same time on the same date are equal
        (comparison should return 0) regardless of duration
        '''

        ## NOTE: Docstring has been updated
        
        pass
                
    def get_description(self):
        '''Return a str representing the event's description'''
        pass
    
    def get_date(self):
        '''Return a datetime object that reflects the start time of the event.
        All-day events should 'start' at 00:00'''
        pass
        
    def is_all_day(self):
        '''Return True iff the event is an all-day event'''
        pass
        
    def get_duration(self):
        '''Return an integer representing the duration in minutes of the event'''
        pass
        
    def conflict(self, other):
        '''Return True iff the time during which other is supposed to occur
        conflicts with the time for self. If an event starts at the precise
        time the other ends, they are not in conflict.
        All-day events do not conflict with each other or with other events.'''
        
        pass