from datetime import *
from event import *
from database import *


e = Event("Description monkey",date(2000,12,31),None,60)
e2 = Event("Description apple",date(2000,12,31),(14,55),60)
e3 = Event("Description apple",date(2000,12,10),(14,55),60)

def test_database_add_events():
    db = Database()
    db.add_event(e)
    assert db.all_events() == [e], "add_event or all_events not implemented correctly"

def test_database_all_events_returned():
    db = Database()
    db.add_event(e)
    db.add_event(e2)
    db.add_event(e3)
    l = db.all_events()
    assert e in l and e2 in l and e3 in l, "database fails to add some events"

def test_database_all_events_order():
    db = Database()
    db.add_event(e)
    db.add_event(e2)
    db.add_event(e3)
    l = db.all_events()
    assert l == [e3,e,e2], "all_events return list not sorted"

def test_database_date():
    db = Database()
    db.add_event(e)
    db.add_event(e2)
    db.add_event(e3)
    db.pop_day((10,12,2000))
    assert db.all_events() == [e,e2], "pop_day doesn't work"

def test_database_search():
        db = Database()
        db.add_event(e)
        db.add_event(e2)
        db.add_event(e3)
        assert db.search_events("App") == [e3,e2], "search doesn't work"


if __name__ == "__main__":
    test_database_add_events()
    test_database_all_events_returned()
    test_database_order()
    test_database_date()
    test_database_search()