from datetime import *
import calendar
import nose
from event import *

def test_event_init_all_day():
    e = Event("Description description",date(2000,12,31),None,60)
    assert e.is_all_day(), "allday attribute not initialized correctly"

def test_event_init_datetime():
    e = Event("Description description",date(2000,12,31),(14,55),60)
    assert e.get_date() == datetime(2000,12,31,14,55), "ondate attribute not initialized correctly"
    
def test_event_compare_by_date():
    e = Event("Description description",date(2000,2,7),None,30)
    e2 = Event("Description description",date(2000,2,8),None,30)
    assert e < e2 and e2 > e and not e == e2, "comparison generated incorrectly"

def test_event_compare_all_day_and_timed():
    e = Event("Description description",date(2000,2,7),None,30)
    e2 = Event("Description description",date(2000,2,7),(15,50),30)
    assert e < e2 and e2 > e and not e == e2, "comparison generated incorrectly"

def test_print_all_day():
    e = Event("Description description",date(2000,2,7),None,60)
    assert str(e) == "2000-02-07 ALL DAY - Description description", "__str__ formatting wrong for all day event"    

def test_print_timed():
    e = Event("Description description",date(2000,2,7),(7,30),5)
    print e
    assert str(e) == "2000-02-07   07:30 - Description description (5 minutes)", "__str__ formatting wrong for timed event"    

if __name__ == "__main__":
    nose.runmodule()